; ***********************************************************

;       Name: Image
;       Author: Peter Kleissner
;       Version: 0.1
;       Date: 17.02.2008 14:02:06
;       last Update: 17.02.2008 14:02:08

;       Forensic Lockdown Software
;       (C) 2008 Vienna Computer Products

;       Compile this file to create the Master Boot Record.

; ***********************************************************


; assemble this file to create the Master Boot Record for Hard Disks

%include "Kernel Storage.asm"


;   Bootloader              512 B
;   System Loader             2 KB
;   Textmode TUI              1 KB
;   Disk System               8 KB
;   Load API RM               2 KB
;   Rescue Module           512 B
;   [Boot Application]        8 KB preserved
;   Crypto Module           1.5 KB
;   Boot Module               1 KB
;   Windows                   4 KB
;  --------------------------------
;   Total Modules Size     28.5 KB
;   (unused space)          2.0 KB
;   Backup Bootloader       0.5 KB
;   Configuration Area      0.5 KB
;  --------------------------------
;   Master Boot Record     31.5 KB


; include the Bootloader
incbin	"Bootloader.sys"
times 512-($-$$) db 0


; include the System Loader
incbin	"System Loader.sys"
times 512+2048-($-$$) db 0


; include the Textmode Text User Interface
incbin	"Textmode TUI.sys"
times 512+2048+1024-($-$$) db 0


; include the Disk System
incbin	"Disk System.sys"
times 512+2048+1024+8192-($-$$) db 0


; include the Load Application Programming Interface for Real Mode
incbin	"API [RM].sys"
times 512+2048+1024+8192+2048-($-$$) db 0


; include the Rescue Module
incbin	"Rescue Module.sys"
times 512+2048+1024+8192+2048+512-($-$$) db 0


; include the User Interface
;incbin	"User Interface.sys"
;times 512+2048+1024+8192+2048+512+4096-($-$$) db 0


; include the Hibernation File Attack Application
;incbin	"Hibernation File Attack.sys"
;times 512+2048+1024+8192+2048+512+4096+4096-($-$$) db 0


; space preserved for a boot application
times 512+2048+1024+8192+2048+512+8192-($-$$) db 0


; include the Hibernation File Attack Application
incbin	"Crypto Module.sys"
times 512+2048+1024+8192+2048+512+4096+4096+1536-($-$$) db 0


; include the Hibernation File Attack Application
incbin	"Boot Module.sys"
times 512+2048+1024+8192+2048+512+4096+4096+1536+1024-($-$$) db 0


; include Pwn Windows
incbin	"Windows.sys"
times 512+2048+1024+8192+2048+512+4096+4096+1536+1024+4096-($-$$) db 0


; Backup Original Bootloader (for test environment: pre-boot Windows XP SP2)
times 61*512 - ($-$$)   db 0
;incbin	"pre-boot\Original Bootloader.bin"
;incbin	"pre-boot\TrueCrypt Boot Sector.sec"


; include the Configuration Area
times 62*512 - ($-$$)   db 0
;%include "Configuration Area.asm"


; whole Master Boot Record size
times 63*512 - ($-$$)   db 0

